#include <advent_utility.h>
#include <stdio.h>
#include <stdlib.h>

#include "lfinput.h"

void advent2017day02(void) {
    size_t sz = 0;
    char **input = get_lines("input/2017/02", &sz);
    int p1 = 0, p2 = 0;

    for (size_t i = 0; i < sz; ++i) {
        Vector *v = string_to_int_vector(input[i], DEFAULT_DELIM);

        const int *max = vec_max(v, vec_cmp_int);
        const int *min = vec_min(v, vec_cmp_int);
        p1 += *max - *min;

        for (size_t j = 0; j < vec_len(v); ++j) {
            for (size_t k = 0; k < vec_len(v); ++k) {
                if (j != k && *(int*)vec_at(v, j) % *(int*)vec_at(v, k) == 0) {
                    p2 += *(int*)vec_at(v, j) / *(int*)vec_at(v, k);
                    goto NEXT_LINE;
                }
            }
        }

NEXT_LINE:
        vec_destroy(v);
        free(v);
    }

    printf("%d\n%d\n", p1, p2);

    free(input);
}
